Solid Example: Row Pinning

import {
  columnFilteringFeature,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  createTable,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowPinningFeature,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, Show, createMemo, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type {
  Column,
  ExpandedState,
  Row,
  RowPinningState,
  SolidTable,
  Table,
} from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({
  rowPinningFeature,
  rowExpandingFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  filteredRowModel: createFilteredRowModel(),
  expandedRowModel: createExpandedRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: {
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
})

function App() {
  const [rowPinning, setRowPinning] = createSignal<RowPinningState>({
    top: [],
    bottom: [],
  })
  const [expanded, setExpanded] = createSignal<ExpandedState>({})

  const [keepPinnedRows, setKeepPinnedRows] = createSignal(true)
  const [includeLeafRows, setIncludeLeafRows] = createSignal(true)
  const [includeParentRows, setIncludeParentRows] = createSignal(false)
  const [copyPinnedRows, setCopyPinnedRows] = createSignal(false)

  const [data, setData] = createSignal(makeData(1_000, 2, 2))
  const refreshData = () => setData(makeData(1_000, 2, 2))
  const stressTest = () => setData(makeData(200_000, 2, 2))

  const columns = createMemo(() => [
    {
      id: 'pin',
      header: () => 'Pin',
      cell: ({ row }: { row: Row<typeof features, Person> }) =>
        row.getIsPinned() ? (
          <button
            onClick={() =>
              row.pin(false, includeLeafRows(), includeParentRows())
            }
          >
            ❌
          </button>
        ) : (
          <div style={{ display: 'flex', gap: '4px' }}>
            <button
              onClick={() =>
                row.pin('top', includeLeafRows(), includeParentRows())
              }
            >
              ⬆️
            </button>
            <button
              onClick={() =>
                row.pin('bottom', includeLeafRows(), includeParentRows())
              }
            >
              ⬇️
            </button>
          </div>
        ),
    },
    {
      accessorKey: 'firstName',
      header: ({ table }: { table: Table<typeof features, Person> }) => (
        <>
          <button onClick={table.getToggleAllRowsExpandedHandler()}>
            {table.getIsAllRowsExpanded() ? '👇' : '👉'}
          </button>{' '}
          First Name
        </>
      ),
      cell: ({
        row,
        getValue,
      }: {
        row: Row<typeof features, Person>
        getValue: () => unknown
      }) => (
        <div style={{ 'padding-left': `${row.depth * 2}rem` }}>
          {row.getCanExpand() ? (
            <button
              onClick={row.getToggleExpandedHandler()}
              style={{ cursor: 'pointer' }}
            >
              {row.getIsExpanded() ? '👇' : '👉'}
            </button>
          ) : (
            '🔵'
          )}{' '}
          {getValue() as string}
        </div>
      ),
      footer: (props: any) => props.column.id,
    },
    {
      accessorFn: (row: Person) => row.lastName,
      id: 'lastName',
      cell: (info: any) => info.getValue(),
      header: () => <span>Last Name</span>,
    },
    { accessorKey: 'age', header: () => 'Age', size: 50 },
    { accessorKey: 'visits', header: () => <span>Visits</span>, size: 50 },
    { accessorKey: 'status', header: 'Status' },
    { accessorKey: 'progress', header: 'Profile Progress', size: 80 },
  ])

  const table = createTable({
    features,
    get columns() {
      return columns()
    },
    get data() {
      return data()
    },
    initialState: {
      pagination: { pageSize: 20, pageIndex: 0 },
      // rowPinning: { top: ['0'], bottom: ['1'] }, // pin rows on first render
    },
    get state() {
      return {
        expanded: expanded(),
        rowPinning: rowPinning(),
      }
    },
    onExpandedChange: setExpanded,
    onRowPinningChange: setRowPinning,
    getSubRows: (row) => row.subRows,
    get keepPinnedRows() {
      return keepPinnedRows()
    },
    // atoms: { rowPinning: rowPinningAtom }, // preferred: own pinning state with an external atom
    // enableRowPinning: row => row.original.age > 18, // allow pinning only for matching rows; default true
    debugTable: true,
    debugAll: true,
  })

  return (
    <div class="app">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (200k rows)</button>
      </div>
      <div class="demo-root container">
        <div class="spacer-sm" />
        <table>
          <thead>
            <For each={table.getHeaderGroups()}>
              {(headerGroup) => (
                <tr>
                  <For each={headerGroup.headers}>
                    {(header) => (
                      <th colSpan={header.colSpan}>
                        <Show when={!header.isPlaceholder}>
                          <>
                            <table.FlexRender header={header} />
                            <Show when={header.column.getCanFilter()}>
                              <div>
                                <Filter column={header.column} table={table} />
                              </div>
                            </Show>
                          </>
                        </Show>
                      </th>
                    )}
                  </For>
                </tr>
              )}
            </For>
          </thead>
          <tbody>
            <For each={table.getTopRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
            <For
              each={
                copyPinnedRows()
                  ? table.getRowModel().rows
                  : table.getCenterRows()
              }
            >
              {(row) => (
                <tr>
                  <For each={row.getAllCells()}>
                    {(cell) => (
                      <td>
                        <table.FlexRender cell={cell} />
                      </td>
                    )}
                  </For>
                </tr>
              )}
            </For>
            <For each={table.getBottomRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
          </tbody>
        </table>
      </div>

      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(0)}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(table.getPageCount() - 1)}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(e) => {
              const page = e.currentTarget.value
                ? Number(e.currentTarget.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(e) => table.setPageSize(Number(e.currentTarget.value))}
        >
          <For each={[10, 20, 30, 40, 50]}>
            {(pageSize) => <option value={pageSize}>Show {pageSize}</option>}
          </For>
        </select>
      </div>
      <div class="spacer-sm" />
      <hr />
      <br />
      <div class="vertical-options">
        <div>
          <input
            type="checkbox"
            checked={keepPinnedRows()}
            onChange={() => setKeepPinnedRows(!keepPinnedRows())}
          />
          <label class="label-offset">
            Keep/Persist Pinned Rows across Pagination and Filtering
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeLeafRows()}
            onChange={() => setIncludeLeafRows(!includeLeafRows())}
          />
          <label class="label-offset">
            Include Leaf Rows When Pinning Parent
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeParentRows()}
            onChange={() => setIncludeParentRows(!includeParentRows())}
          />
          <label class="label-offset">
            Include Parent Rows When Pinning Child
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={copyPinnedRows()}
            onChange={() => setCopyPinnedRows(!copyPinnedRows())}
          />
          <label class="label-offset">
            Duplicate/Keep Pinned Rows in main table
          </label>
        </div>
      </div>
      <pre data-testid="table-state">
        {JSON.stringify(table.store.get(), null, 2)}
      </pre>
    </div>
  )
}

function PinnedRow(props: {
  row: Row<typeof features, Person>
  table: SolidTable<typeof features, Person>
}) {
  return (
    <tr
      style={{
        'background-color': 'lightblue',
        position: 'sticky',
        top:
          props.row.getIsPinned() === 'top'
            ? `${props.row.getPinnedIndex() * 26 + 48}px`
            : undefined,
        bottom:
          props.row.getIsPinned() === 'bottom'
            ? `${(props.table.getBottomRows().length - 1 - props.row.getPinnedIndex()) * 26}px`
            : undefined,
      }}
    >
      <For each={props.row.getAllCells()}>
        {(cell) => (
          <td>
            <props.table.FlexRender cell={cell} />
          </td>
        )}
      </For>
    </tr>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: Table<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  return typeof firstValue === 'number' ? (
    <div class="filter-row">
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[0] ?? '') as string}
        onInput={(e) =>
          column.setFilterValue((old: any) => [e.currentTarget.value, old?.[1]])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[1] ?? '') as string}
        onInput={(e) =>
          column.setFilterValue((old: any) => [old?.[0], e.currentTarget.value])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  ) : (
    <input
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      onInput={(e) => column.setFilterValue(e.currentTarget.value)}
      placeholder="Search..."
      class="filter-select"
    />
  )
}

export default App
import {
  columnFilteringFeature,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  createTable,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowPinningFeature,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, Show, createMemo, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type {
  Column,
  ExpandedState,
  Row,
  RowPinningState,
  SolidTable,
  Table,
} from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({
  rowPinningFeature,
  rowExpandingFeature,
  columnFilteringFeature,
  rowPaginationFeature,
  filteredRowModel: createFilteredRowModel(),
  expandedRowModel: createExpandedRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: {
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
})

function App() {
  const [rowPinning, setRowPinning] = createSignal<RowPinningState>({
    top: [],
    bottom: [],
  })
  const [expanded, setExpanded] = createSignal<ExpandedState>({})

  const [keepPinnedRows, setKeepPinnedRows] = createSignal(true)
  const [includeLeafRows, setIncludeLeafRows] = createSignal(true)
  const [includeParentRows, setIncludeParentRows] = createSignal(false)
  const [copyPinnedRows, setCopyPinnedRows] = createSignal(false)

  const [data, setData] = createSignal(makeData(1_000, 2, 2))
  const refreshData = () => setData(makeData(1_000, 2, 2))
  const stressTest = () => setData(makeData(200_000, 2, 2))

  const columns = createMemo(() => [
    {
      id: 'pin',
      header: () => 'Pin',
      cell: ({ row }: { row: Row<typeof features, Person> }) =>
        row.getIsPinned() ? (
          <button
            onClick={() =>
              row.pin(false, includeLeafRows(), includeParentRows())
            }
          >
            ❌
          </button>
        ) : (
          <div style={{ display: 'flex', gap: '4px' }}>
            <button
              onClick={() =>
                row.pin('top', includeLeafRows(), includeParentRows())
              }
            >
              ⬆️
            </button>
            <button
              onClick={() =>
                row.pin('bottom', includeLeafRows(), includeParentRows())
              }
            >
              ⬇️
            </button>
          </div>
        ),
    },
    {
      accessorKey: 'firstName',
      header: ({ table }: { table: Table<typeof features, Person> }) => (
        <>
          <button onClick={table.getToggleAllRowsExpandedHandler()}>
            {table.getIsAllRowsExpanded() ? '👇' : '👉'}
          </button>{' '}
          First Name
        </>
      ),
      cell: ({
        row,
        getValue,
      }: {
        row: Row<typeof features, Person>
        getValue: () => unknown
      }) => (
        <div style={{ 'padding-left': `${row.depth * 2}rem` }}>
          {row.getCanExpand() ? (
            <button
              onClick={row.getToggleExpandedHandler()}
              style={{ cursor: 'pointer' }}
            >
              {row.getIsExpanded() ? '👇' : '👉'}
            </button>
          ) : (
            '🔵'
          )}{' '}
          {getValue() as string}
        </div>
      ),
      footer: (props: any) => props.column.id,
    },
    {
      accessorFn: (row: Person) => row.lastName,
      id: 'lastName',
      cell: (info: any) => info.getValue(),
      header: () => <span>Last Name</span>,
    },
    { accessorKey: 'age', header: () => 'Age', size: 50 },
    { accessorKey: 'visits', header: () => <span>Visits</span>, size: 50 },
    { accessorKey: 'status', header: 'Status' },
    { accessorKey: 'progress', header: 'Profile Progress', size: 80 },
  ])

  const table = createTable({
    features,
    get columns() {
      return columns()
    },
    get data() {
      return data()
    },
    initialState: {
      pagination: { pageSize: 20, pageIndex: 0 },
      // rowPinning: { top: ['0'], bottom: ['1'] }, // pin rows on first render
    },
    get state() {
      return {
        expanded: expanded(),
        rowPinning: rowPinning(),
      }
    },
    onExpandedChange: setExpanded,
    onRowPinningChange: setRowPinning,
    getSubRows: (row) => row.subRows,
    get keepPinnedRows() {
      return keepPinnedRows()
    },
    // atoms: { rowPinning: rowPinningAtom }, // preferred: own pinning state with an external atom
    // enableRowPinning: row => row.original.age > 18, // allow pinning only for matching rows; default true
    debugTable: true,
    debugAll: true,
  })

  return (
    <div class="app">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (200k rows)</button>
      </div>
      <div class="demo-root container">
        <div class="spacer-sm" />
        <table>
          <thead>
            <For each={table.getHeaderGroups()}>
              {(headerGroup) => (
                <tr>
                  <For each={headerGroup.headers}>
                    {(header) => (
                      <th colSpan={header.colSpan}>
                        <Show when={!header.isPlaceholder}>
                          <>
                            <table.FlexRender header={header} />
                            <Show when={header.column.getCanFilter()}>
                              <div>
                                <Filter column={header.column} table={table} />
                              </div>
                            </Show>
                          </>
                        </Show>
                      </th>
                    )}
                  </For>
                </tr>
              )}
            </For>
          </thead>
          <tbody>
            <For each={table.getTopRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
            <For
              each={
                copyPinnedRows()
                  ? table.getRowModel().rows
                  : table.getCenterRows()
              }
            >
              {(row) => (
                <tr>
                  <For each={row.getAllCells()}>
                    {(cell) => (
                      <td>
                        <table.FlexRender cell={cell} />
                      </td>
                    )}
                  </For>
                </tr>
              )}
            </For>
            <For each={table.getBottomRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
          </tbody>
        </table>
      </div>

      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(0)}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(table.getPageCount() - 1)}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(e) => {
              const page = e.currentTarget.value
                ? Number(e.currentTarget.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(e) => table.setPageSize(Number(e.currentTarget.value))}
        >
          <For each={[10, 20, 30, 40, 50]}>
            {(pageSize) => <option value={pageSize}>Show {pageSize}</option>}
          </For>
        </select>
      </div>
      <div class="spacer-sm" />
      <hr />
      <br />
      <div class="vertical-options">
        <div>
          <input
            type="checkbox"
            checked={keepPinnedRows()}
            onChange={() => setKeepPinnedRows(!keepPinnedRows())}
          />
          <label class="label-offset">
            Keep/Persist Pinned Rows across Pagination and Filtering
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeLeafRows()}
            onChange={() => setIncludeLeafRows(!includeLeafRows())}
          />
          <label class="label-offset">
            Include Leaf Rows When Pinning Parent
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeParentRows()}
            onChange={() => setIncludeParentRows(!includeParentRows())}
          />
          <label class="label-offset">
            Include Parent Rows When Pinning Child
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={copyPinnedRows()}
            onChange={() => setCopyPinnedRows(!copyPinnedRows())}
          />
          <label class="label-offset">
            Duplicate/Keep Pinned Rows in main table
          </label>
        </div>
      </div>
      <pre data-testid="table-state">
        {JSON.stringify(table.store.get(), null, 2)}
      </pre>
    </div>
  )
}

function PinnedRow(props: {
  row: Row<typeof features, Person>
  table: SolidTable<typeof features, Person>
}) {
  return (
    <tr
      style={{
        'background-color': 'lightblue',
        position: 'sticky',
        top:
          props.row.getIsPinned() === 'top'
            ? `${props.row.getPinnedIndex() * 26 + 48}px`
            : undefined,
        bottom:
          props.row.getIsPinned() === 'bottom'
            ? `${(props.table.getBottomRows().length - 1 - props.row.getPinnedIndex()) * 26}px`
            : undefined,
      }}
    >
      <For each={props.row.getAllCells()}>
        {(cell) => (
          <td>
            <props.table.FlexRender cell={cell} />
          </td>
        )}
      </For>
    </tr>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: Table<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  return typeof firstValue === 'number' ? (
    <div class="filter-row">
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[0] ?? '') as string}
        onInput={(e) =>
          column.setFilterValue((old: any) => [e.currentTarget.value, old?.[1]])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[1] ?? '') as string}
        onInput={(e) =>
          column.setFilterValue((old: any) => [old?.[0], e.currentTarget.value])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  ) : (
    <input
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      onInput={(e) => column.setFilterValue(e.currentTarget.value)}
      placeholder="Search..."
      class="filter-select"
    />
  )
}

export default App

TanStack
Table betabeta
Libraries
Framework
StartRC
Docs
Router
Docs
Data & State Management
Query
Docs
DBbeta
Docs
Storealpha
Docs
AIbeta
Docs
UI & UX
Table
Docs
Formnew
Docs
Hotkeysalpha
Docs
Performance
Virtual
Docs
Pacerbeta
Docs
Tooling
Devtoolsalpha
Docs
Config
Docs
CLIalpha
Docs
Intentalpha
Docs
Resources
BlogRelease notes, architecture notes, and essays.YouTubeThe official TanStack channel.
Workshops
Learn from maintainers

Remote and in-person TanStack workshops for teams that need depth.

Professional Workshops
Channels
DiscordCommunity support and real-time discussion.GitHubSource, issues, discussions, and releases.
People & Work
MaintainersMeet the people maintaining the stack.ContributorsCore, library, and community contributors.ShowcaseProducts and teams building with TanStack.
Tools
BuilderAlphaGenerate TanStack app starters.StatsNPM and ecosystem usage data.
Merch
Recent Products
All MerchBrowse all TanStack apparel, accessories, and stickers.
Support
Support OverviewFind the right support path.PartnersCompanies supporting TanStack.OSS SponsorsSponsors keeping TanStack open source.Enterprise SupportPrivate consulting and expert support.ContactGet in touch with the TanStack team.
About
EthosHow we think about open source and products.TenetsThe values that shape TanStack libraries.Brand GuideLogos, colors, and brand usage.
Partners
Work with TanStack

Sponsorships, placements, and partner pages.

Partnership Inquiry
Log In
Log In
All LibrariesBrowse the full set of public packages.
Framework
StartRC
Docs
Router
Docs
Data & State Management
Query
Docs
DBbeta
Docs
Storealpha
Docs
AIbeta
Docs
UI & UX
Table
Docs
Formnew
Docs
Hotkeysalpha
Docs
Performance
Virtual
Docs
Pacerbeta
Docs
Tooling
Devtoolsalpha
Docs
Config
Docs
CLIalpha
Docs
Intentalpha
Docs
Resources
BlogRelease notes, architecture notes, and essays.YouTubeThe official TanStack channel.
Professional Workshops
Channels
DiscordCommunity support and real-time discussion.GitHubSource, issues, discussions, and releases.
People & Work
MaintainersMeet the people maintaining the stack.ContributorsCore, library, and community contributors.ShowcaseProducts and teams building with TanStack.
Tools
BuilderAlphaGenerate TanStack app starters.StatsNPM and ecosystem usage data.
Recent Products
All MerchBrowse all TanStack apparel, accessories, and stickers.
Support
Support OverviewFind the right support path.PartnersCompanies supporting TanStack.OSS SponsorsSponsors keeping TanStack open source.Enterprise SupportPrivate consulting and expert support.ContactGet in touch with the TanStack team.
About
EthosHow we think about open source and products.TenetsThe values that shape TanStack libraries.Brand GuideLogos, colors, and brand usage.
Partnership Inquiry
Docs
Basic Examples
  • Basic (useTable)
  • Basic (useAppTable)
  • Basic (External State)
  • Basic (External Atoms)
  • Basic (Dynamic Columns)
  • Header Groups
Feature Examples
  • Kitchen Sink (All Features)
  • Cell Selection
  • Cell Spanning
  • Column Filters
  • Column Filters (Faceted)
  • Bucketed Faceted Filters
  • Fuzzy Search Filters
  • Column Ordering
  • Column Pinning
  • Column Pinning (Split)
  • Sticky Column Pinning
  • Column Sizing
  • Column Resizing
  • Performant Column Resizing
  • Column Visibility
  • Expanding
  • Expanding Sub Components
  • Grouping
  • Aggregation
  • Grouped Aggregation
  • Pagination
  • Row Pinning
  • Row Selection
  • Sorting
Specialized Examples
  • Composable Tables (createTableHook)
  • With TanStack Virtual - Columns
  • With TanStack Virtual - Rows
  • With TanStack Virtual - Infinite Scrolling
  • With TanStack Form
  • With TanStack Query
HomeGet StartedGuidesAPIExamples
Basic Examples
  • Basic (useTable)
  • Basic (useAppTable)
  • Basic (External State)
  • Basic (External Atoms)
  • Basic (Dynamic Columns)
  • Header Groups
Feature Examples
  • Kitchen Sink (All Features)
  • Cell Selection
  • Cell Spanning
  • Column Filters
  • Column Filters (Faceted)
  • Bucketed Faceted Filters
  • Fuzzy Search Filters
  • Column Ordering
  • Column Pinning
  • Column Pinning (Split)
  • Sticky Column Pinning
  • Column Sizing
  • Column Resizing
  • Performant Column Resizing
  • Column Visibility
  • Expanding
  • Expanding Sub Components
  • Grouping
  • Aggregation
  • Grouped Aggregation
  • Pagination
  • Row Pinning
  • Row Selection
  • Sorting
Specialized Examples
  • Composable Tables (createTableHook)
  • With TanStack Virtual - Columns
  • With TanStack Virtual - Rows
  • With TanStack Virtual - Infinite Scrolling
  • With TanStack Form
  • With TanStack Query

Vue Example: Row Pinning
GitHub StackBlitz CodeSandbox

<script setup lang="ts">
import AppImpl from './App.tsx'
</script>

<template>
  <AppImpl />
</template>
<script setup lang="ts">
import AppImpl from './App.tsx'
</script>

<template>
  <AppImpl />
</template>
Blog
@Tan_Stack on X.com
@TannerLinsley on X.com
GitHub
YouTube
Nozzle.io - Keyword Rank Tracker
Ethos
Tenets
Privacy Policy
Terms of Service
© 2026 TanStack LLC
PartnersBecome a Partner
Gold
CloudflareCloudflare
RailwayRailway
CodeRabbitCodeRabbit
Silver
NetlifyNetlify
AG GridAG Grid
WorkOSWorkOS
ClerkClerk
OpenRouterOpenRouter
SerpAPISerpAPI
Bronze
PrismaPrisma
SentrySentry
UnkeyUnkey
ElectricElectric
    Latest Posts
    TanStack Start and TanStack AI Win 2026 Open Source AwardsJun 22, 2026How an Underrated Refactor Saved 90% Memory UsageJun 22, 2026TypeScript Performance in TanStack Table V9Jun 14, 2026

React Example: Row Pinning

import React from 'react'
import ReactDOM from 'react-dom/client'
import {
  columnFilteringFeature,
  columnSizingFeature,
  createColumnHelper,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowPinningFeature,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import { useDebouncedCallback } from '@tanstack/react-pacer/debouncer'
import { makeData } from './makeData'
import type { Person } from './makeData'
import type {
  Column,
  ExpandedState,
  ReactTable,
  Row,
  RowPinningState,
} from '@tanstack/react-table'
import './index.css'

const features = tableFeatures({
  rowPinningFeature,
  rowExpandingFeature,
  columnFilteringFeature,
  columnSizingFeature,
  rowPaginationFeature,
  filteredRowModel: createFilteredRowModel(),
  expandedRowModel: createExpandedRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: {
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()
function App() {
  // table states
  const [rowPinning, setRowPinning] = React.useState<RowPinningState>({
    top: [],
    bottom: [],
  })
  const [expanded, setExpanded] = React.useState<ExpandedState>({})

  // demo states
  const [keepPinnedRows, setKeepPinnedRows] = React.useState(true)
  const [includeLeafRows, setIncludeLeafRows] = React.useState(true)
  const [includeParentRows, setIncludeParentRows] = React.useState(false)
  const [copyPinnedRows, setCopyPinnedRows] = React.useState(false)

  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.display({
          id: 'pin',
          header: () => 'Pin',
          cell: ({ row }) =>
            row.getIsPinned() ? (
              <button
                onClick={() =>
                  row.pin(false, includeLeafRows, includeParentRows)
                }
              >
                ❌
              </button>
            ) : (
              <div style={{ display: 'flex', gap: '4px' }}>
                <button
                  onClick={() =>
                    row.pin('top', includeLeafRows, includeParentRows)
                  }
                >
                  ⬆️
                </button>
                <button
                  onClick={() =>
                    row.pin('bottom', includeLeafRows, includeParentRows)
                  }
                >
                  ⬇️
                </button>
              </div>
            ),
        }),
        columnHelper.accessor('firstName', {
          header: ({ table }) => (
            <>
              <button onClick={table.getToggleAllRowsExpandedHandler()}>
                {table.getIsAllRowsExpanded() ? '👇' : '👉'}
              </button>{' '}
              First Name
            </>
          ),
          cell: ({ row, getValue }) => (
            <div
              style={{
                // Since rows are flattened by default,
                // we can use the row.depth property
                // and paddingLeft to visually indicate the depth
                // of the row
                paddingLeft: `${row.depth * 2}rem`,
              }}
            >
              <>
                {row.getCanExpand() ? (
                  <button
                    onClick={row.getToggleExpandedHandler()}
                    style={{ cursor: 'pointer' }}
                  >
                    {row.getIsExpanded() ? '👇' : '👉'}
                  </button>
                ) : (
                  '🔵'
                )}{' '}
                {getValue()}
              </>
            </div>
          ),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => <span>Last Name</span>,
        }),
        columnHelper.accessor('age', {
          header: () => 'Age',
          size: 50,
        }),
        columnHelper.accessor('visits', {
          header: () => <span>Visits</span>,
          size: 50,
        }),
        columnHelper.accessor('status', {
          header: 'Status',
        }),
        columnHelper.accessor('progress', {
          header: 'Profile Progress',
          size: 80,
        }),
      ]),
    [includeLeafRows, includeParentRows],
  )

  const [data, setData] = React.useState(() => makeData(1_000, 2, 2))
  const refreshData = () => setData(makeData(1_000, 2, 2))
  const stressTest = () => setData(makeData(200_000, 2, 2))

  const table = useTable(
    {
      features,
      columns,
      data,
      initialState: {
        pagination: { pageSize: 20, pageIndex: 0 },
        // rowPinning: { top: ['0'], bottom: ['1'] }, // pin rows on first render
      },
      state: {
        expanded,
        rowPinning,
      },
      onExpandedChange: setExpanded,
      onRowPinningChange: setRowPinning,
      getSubRows: (row) => row.subRows,
      keepPinnedRows,
      // atoms: { rowPinning: rowPinningAtom }, // preferred: own pinning state with an external atom
      // enableRowPinning: row => row.original.age > 18, // allow pinning only for matching rows; default true
      debugTable: true,
      debugAll: true,
    },
    (state) => state, // default selector
  )

  // console.log(table.getBottomRows)
  // React.useEffect(() => {
  //   console.log(table.getBottomRows())
  //
  // }, [table.getBottomRows()])

  return (
    <div className="app">
      <div className="demo-root container">
        <div>
          <button
            className="demo-button demo-button-spaced"
            onClick={() => refreshData()}
          >
            Regenerate Data
          </button>
          <button
            className="demo-button demo-button-spaced"
            onClick={() => stressTest()}
          >
            Stress Test (200k rows)
          </button>
        </div>
        <div className="spacer-sm" />
        <table>
          <thead>
            {table.getHeaderGroups().map((headerGroup) => (
              <tr key={headerGroup.id}>
                {headerGroup.headers.map((header) => {
                  return (
                    <th key={header.id} colSpan={header.colSpan}>
                      {header.isPlaceholder ? null : (
                        <>
                          <table.FlexRender header={header} />
                          {header.column.getCanFilter() ? (
                            <div>
                              <Filter column={header.column} table={table} />
                            </div>
                          ) : null}
                        </>
                      )}
                    </th>
                  )
                })}
              </tr>
            ))}
          </thead>
          <tbody>
            {table.getTopRows().map((row) => (
              <PinnedRow key={row.id} row={row} table={table} />
            ))}
            {(copyPinnedRows
              ? table.getRowModel().rows
              : table.getCenterRows()
            ).map((row) => {
              return (
                <tr key={row.id}>
                  {row.getAllCells().map((cell) => {
                    return (
                      <td key={cell.id}>
                        <table.FlexRender cell={cell} />
                      </td>
                    )
                  })}
                </tr>
              )
            })}
            {table.getBottomRows().map((row) => (
              <PinnedRow key={row.id} row={row} table={table} />
            ))}
          </tbody>
        </table>
      </div>

      <div className="spacer-sm" />
      <div className="controls">
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span className="inline-controls">
          <div>Page</div>
          <strong>
            {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span className="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.state.pagination.pageIndex + 1}
            onChange={(e) => {
              const page = e.target.value ? Number(e.target.value) - 1 : 0
              table.setPageIndex(page)
            }}
            className="page-size-input"
          />
        </span>
        <select
          value={table.state.pagination.pageSize}
          onChange={(e) => {
            table.setPageSize(Number(e.target.value))
          }}
        >
          {[10, 20, 30, 40, 50].map((pageSize) => (
            <option key={pageSize} value={pageSize}>
              Show {pageSize}
            </option>
          ))}
        </select>
      </div>
      <div className="spacer-sm" />
      <hr />
      <br />
      <div className="vertical-options">
        <div>
          <input
            type="checkbox"
            checked={keepPinnedRows}
            onChange={() => setKeepPinnedRows(!keepPinnedRows)}
          />
          <label className="label-offset">
            Keep/Persist Pinned Rows across Pagination and Filtering
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeLeafRows}
            onChange={() => setIncludeLeafRows(!includeLeafRows)}
          />
          <label className="label-offset">
            Include Leaf Rows When Pinning Parent
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeParentRows}
            onChange={() => setIncludeParentRows(!includeParentRows)}
          />
          <label className="label-offset">
            Include Parent Rows When Pinning Child
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={copyPinnedRows}
            onChange={() => setCopyPinnedRows(!copyPinnedRows)}
          />
          <label className="label-offset">
            Duplicate/Keep Pinned Rows in main table
          </label>
        </div>
      </div>
      <div></div>
      <pre data-testid="table-state">
        {JSON.stringify(table.state, null, 2)}
      </pre>
    </div>
  )
}

function PinnedRow({
  row,
  table,
}: {
  row: Row<typeof features, Person>
  table: ReactTable<typeof features, Person>
}) {
  return (
    <tr
      style={{
        backgroundColor: 'lightblue',
        position: 'sticky',
        top:
          row.getIsPinned() === 'top'
            ? `${row.getPinnedIndex() * 26 + 48}px`
            : undefined,
        bottom:
          row.getIsPinned() === 'bottom'
            ? `${
                (table.getBottomRows().length - 1 - row.getPinnedIndex()) * 26
              }px`
            : undefined,
      }}
    >
      {row.getAllCells().map((cell) => {
        return (
          <td key={cell.id}>
            <table.FlexRender cell={cell} />
          </td>
        )
      })}
    </tr>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: ReactTable<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  return typeof firstValue === 'number' ? (
    <div className="filter-row">
      <DebouncedInput
        type="number"
        value={((column.getFilterValue() as any)?.[0] ?? '') as string}
        onChange={(value) =>
          column.setFilterValue((old: any) => [value, old?.[1]])
        }
        placeholder={`Min`}
        className="filter-input"
      />
      <DebouncedInput
        type="number"
        value={((column.getFilterValue() as any)?.[1] ?? '') as string}
        onChange={(value) =>
          column.setFilterValue((old: any) => [old?.[0], value])
        }
        placeholder={`Max`}
        className="filter-input"
      />
    </div>
  ) : (
    <DebouncedInput
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      onChange={(value) => column.setFilterValue(value)}
      placeholder={`Search...`}
      className="filter-select"
    />
  )
}

// A debounced input react component
function DebouncedInput({
  value: initialValue,
  onChange,
  debounce = 500,
  ...props
}: {
  value: string | number
  onChange: (value: string | number) => void
  debounce?: number
} & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'onChange'>) {
  const [value, setValue] = React.useState(initialValue)

  React.useEffect(() => {
    setValue(initialValue)
  }, [initialValue])

  const debouncedOnChange = useDebouncedCallback(onChange, { wait: debounce })

  return (
    <input
      {...props}
      value={value}
      onChange={(e) => {
        setValue(e.target.value)
        debouncedOnChange(e.target.value)
      }}
    />
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)
import React from 'react'
import ReactDOM from 'react-dom/client'
import {
  columnFilteringFeature,
  columnSizingFeature,
  createColumnHelper,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowPinningFeature,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import { useDebouncedCallback } from '@tanstack/react-pacer/debouncer'
import { makeData } from './makeData'
import type { Person } from './makeData'
import type {
  Column,
  ExpandedState,
  ReactTable,
  Row,
  RowPinningState,
} from '@tanstack/react-table'
import './index.css'

const features = tableFeatures({
  rowPinningFeature,
  rowExpandingFeature,
  columnFilteringFeature,
  columnSizingFeature,
  rowPaginationFeature,
  filteredRowModel: createFilteredRowModel(),
  expandedRowModel: createExpandedRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  filterFns: {
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()
function App() {
  // table states
  const [rowPinning, setRowPinning] = React.useState<RowPinningState>({
    top: [],
    bottom: [],
  })
  const [expanded, setExpanded] = React.useState<ExpandedState>({})

  // demo states
  const [keepPinnedRows, setKeepPinnedRows] = React.useState(true)
  const [includeLeafRows, setIncludeLeafRows] = React.useState(true)
  const [includeParentRows, setIncludeParentRows] = React.useState(false)
  const [copyPinnedRows, setCopyPinnedRows] = React.useState(false)

  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.display({
          id: 'pin',
          header: () => 'Pin',
          cell: ({ row }) =>
            row.getIsPinned() ? (
              <button
                onClick={() =>
                  row.pin(false, includeLeafRows, includeParentRows)
                }
              >
                ❌
              </button>
            ) : (
              <div style={{ display: 'flex', gap: '4px' }}>
                <button
                  onClick={() =>
                    row.pin('top', includeLeafRows, includeParentRows)
                  }
                >
                  ⬆️
                </button>
                <button
                  onClick={() =>
                    row.pin('bottom', includeLeafRows, includeParentRows)
                  }
                >
                  ⬇️
                </button>
              </div>
            ),
        }),
        columnHelper.accessor('firstName', {
          header: ({ table }) => (
            <>
              <button onClick={table.getToggleAllRowsExpandedHandler()}>
                {table.getIsAllRowsExpanded() ? '👇' : '👉'}
              </button>{' '}
              First Name
            </>
          ),
          cell: ({ row, getValue }) => (
            <div
              style={{
                // Since rows are flattened by default,
                // we can use the row.depth property
                // and paddingLeft to visually indicate the depth
                // of the row
                paddingLeft: `${row.depth * 2}rem`,
              }}
            >
              <>
                {row.getCanExpand() ? (
                  <button
                    onClick={row.getToggleExpandedHandler()}
                    style={{ cursor: 'pointer' }}
                  >
                    {row.getIsExpanded() ? '👇' : '👉'}
                  </button>
                ) : (
                  '🔵'
                )}{' '}
                {getValue()}
              </>
            </div>
          ),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => <span>Last Name</span>,
        }),
        columnHelper.accessor('age', {
          header: () => 'Age',
          size: 50,
        }),
        columnHelper.accessor('visits', {
          header: () => <span>Visits</span>,
          size: 50,
        }),
        columnHelper.accessor('status', {
          header: 'Status',
        }),
        columnHelper.accessor('progress', {
          header: 'Profile Progress',
          size: 80,
        }),
      ]),
    [includeLeafRows, includeParentRows],
  )

  const [data, setData] = React.useState(() => makeData(1_000, 2, 2))
  const refreshData = () => setData(makeData(1_000, 2, 2))
  const stressTest = () => setData(makeData(200_000, 2, 2))

  const table = useTable(
    {
      features,
      columns,
      data,
      initialState: {
        pagination: { pageSize: 20, pageIndex: 0 },
        // rowPinning: { top: ['0'], bottom: ['1'] }, // pin rows on first render
      },
      state: {
        expanded,
        rowPinning,
      },
      onExpandedChange: setExpanded,
      onRowPinningChange: setRowPinning,
      getSubRows: (row) => row.subRows,
      keepPinnedRows,
      // atoms: { rowPinning: rowPinningAtom }, // preferred: own pinning state with an external atom
      // enableRowPinning: row => row.original.age > 18, // allow pinning only for matching rows; default true
      debugTable: true,
      debugAll: true,
    },
    (state) => state, // default selector
  )

  // console.log(table.getBottomRows)
  // React.useEffect(() => {
  //   console.log(table.getBottomRows())
  //
  // }, [table.getBottomRows()])

  return (
    <div className="app">
      <div className="demo-root container">
        <div>
          <button
            className="demo-button demo-button-spaced"
            onClick={() => refreshData()}
          >
            Regenerate Data
          </button>
          <button
            className="demo-button demo-button-spaced"
            onClick={() => stressTest()}
          >
            Stress Test (200k rows)
          </button>
        </div>
        <div className="spacer-sm" />
        <table>
          <thead>
            {table.getHeaderGroups().map((headerGroup) => (
              <tr key={headerGroup.id}>
                {headerGroup.headers.map((header) => {
                  return (
                    <th key={header.id} colSpan={header.colSpan}>
                      {header.isPlaceholder ? null : (
                        <>
                          <table.FlexRender header={header} />
                          {header.column.getCanFilter() ? (
                            <div>
                              <Filter column={header.column} table={table} />
                            </div>
                          ) : null}
                        </>
                      )}
                    </th>
                  )
                })}
              </tr>
            ))}
          </thead>
          <tbody>
            {table.getTopRows().map((row) => (
              <PinnedRow key={row.id} row={row} table={table} />
            ))}
            {(copyPinnedRows
              ? table.getRowModel().rows
              : table.getCenterRows()
            ).map((row) => {
              return (
                <tr key={row.id}>
                  {row.getAllCells().map((cell) => {
                    return (
                      <td key={cell.id}>
                        <table.FlexRender cell={cell} />
                      </td>
                    )
                  })}
                </tr>
              )
            })}
            {table.getBottomRows().map((row) => (
              <PinnedRow key={row.id} row={row} table={table} />
            ))}
          </tbody>
        </table>
      </div>

      <div className="spacer-sm" />
      <div className="controls">
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span className="inline-controls">
          <div>Page</div>
          <strong>
            {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span className="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.state.pagination.pageIndex + 1}
            onChange={(e) => {
              const page = e.target.value ? Number(e.target.value) - 1 : 0
              table.setPageIndex(page)
            }}
            className="page-size-input"
          />
        </span>
        <select
          value={table.state.pagination.pageSize}
          onChange={(e) => {
            table.setPageSize(Number(e.target.value))
          }}
        >
          {[10, 20, 30, 40, 50].map((pageSize) => (
            <option key={pageSize} value={pageSize}>
              Show {pageSize}
            </option>
          ))}
        </select>
      </div>
      <div className="spacer-sm" />
      <hr />
      <br />
      <div className="vertical-options">
        <div>
          <input
            type="checkbox"
            checked={keepPinnedRows}
            onChange={() => setKeepPinnedRows(!keepPinnedRows)}
          />
          <label className="label-offset">
            Keep/Persist Pinned Rows across Pagination and Filtering
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeLeafRows}
            onChange={() => setIncludeLeafRows(!includeLeafRows)}
          />
          <label className="label-offset">
            Include Leaf Rows When Pinning Parent
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={includeParentRows}
            onChange={() => setIncludeParentRows(!includeParentRows)}
          />
          <label className="label-offset">
            Include Parent Rows When Pinning Child
          </label>
        </div>
        <div>
          <input
            type="checkbox"
            checked={copyPinnedRows}
            onChange={() => setCopyPinnedRows(!copyPinnedRows)}
          />
          <label className="label-offset">
            Duplicate/Keep Pinned Rows in main table
          </label>
        </div>
      </div>
      <div></div>
      <pre data-testid="table-state">
        {JSON.stringify(table.state, null, 2)}
      </pre>
    </div>
  )
}

function PinnedRow({
  row,
  table,
}: {
  row: Row<typeof features, Person>
  table: ReactTable<typeof features, Person>
}) {
  return (
    <tr
      style={{
        backgroundColor: 'lightblue',
        position: 'sticky',
        top:
          row.getIsPinned() === 'top'
            ? `${row.getPinnedIndex() * 26 + 48}px`
            : undefined,
        bottom:
          row.getIsPinned() === 'bottom'
            ? `${
                (table.getBottomRows().length - 1 - row.getPinnedIndex()) * 26
              }px`
            : undefined,
      }}
    >
      {row.getAllCells().map((cell) => {
        return (
          <td key={cell.id}>
            <table.FlexRender cell={cell} />
          </td>
        )
      })}
    </tr>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: ReactTable<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  return typeof firstValue === 'number' ? (
    <div className="filter-row">
      <DebouncedInput
        type="number"
        value={((column.getFilterValue() as any)?.[0] ?? '') as string}
        onChange={(value) =>
          column.setFilterValue((old: any) => [value, old?.[1]])
        }
        placeholder={`Min`}
        className="filter-input"
      />
      <DebouncedInput
        type="number"
        value={((column.getFilterValue() as any)?.[1] ?? '') as string}
        onChange={(value) =>
          column.setFilterValue((old: any) => [old?.[0], value])
        }
        placeholder={`Max`}
        className="filter-input"
      />
    </div>
  ) : (
    <DebouncedInput
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      onChange={(value) => column.setFilterValue(value)}
      placeholder={`Search...`}
      className="filter-select"
    />
  )
}

// A debounced input react component
function DebouncedInput({
  value: initialValue,
  onChange,
  debounce = 500,
  ...props
}: {
  value: string | number
  onChange: (value: string | number) => void
  debounce?: number
} & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'onChange'>) {
  const [value, setValue] = React.useState(initialValue)

  React.useEffect(() => {
    setValue(initialValue)
  }, [initialValue])

  const debouncedOnChange = useDebouncedCallback(onChange, { wait: debounce })

  return (
    <input
      {...props}
      value={value}
      onChange={(e) => {
        setValue(e.target.value)
        debouncedOnChange(e.target.value)
      }}
    />
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)

Svelte Example: Row Pinning

<script lang="ts">
  import {
    columnFilteringFeature,
    columnSizingFeature,
    createExpandedRowModel,
    createFilteredRowModel,
    createPaginatedRowModel,
    createTable,
    createTableState,
    filterFn_includesString,
    filterFn_inNumberRange,
    FlexRender,
    rowExpandingFeature,
    rowPaginationFeature,
    rowPinningFeature,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type {
    Column,
    ExpandedState,
    RowPinningState,
    SvelteTable,
  } from '@tanstack/svelte-table'
  import type { Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    columnSizingFeature,
    rowPinningFeature,
    rowExpandingFeature,
    columnFilteringFeature,
    rowPaginationFeature,
    filteredRowModel: createFilteredRowModel(),
    expandedRowModel: createExpandedRowModel(),
    paginatedRowModel: createPaginatedRowModel(),
    filterFns: {
      includesString: filterFn_includesString,
      inNumberRange: filterFn_inNumberRange,
    },
  })

  const [rowPinning, setRowPinning] = createTableState<RowPinningState>({
    top: [],
    bottom: [],
  })
  const [expanded, setExpanded] = createTableState<ExpandedState>({})

  let keepPinnedRows = $state(true)
  let includeLeafRows = $state(true)
  let includeParentRows = $state(false)
  let copyPinnedRows = $state(false)

  let data = $state(makeData(1_000, 2, 2))
  const refreshData = () => { data = makeData(1_000, 2, 2) }
  const stressTest = () => { data = makeData(200_000, 2, 2) }

  const table = createTable(
    {
      features,
      columns: [
        {
          id: 'pin',
          header: () => 'Pin',
          cell: ({ row }) => {
            if (row.getIsPinned()) {
              return 'pinned'
            }
            return 'not-pinned'
          },
        },
        {
          accessorKey: 'firstName',
          header: () => 'First Name',
          cell: ({ getValue }) => getValue(),
          footer: (props) => props.column.id,
        },
        {
          accessorFn: (row) => row.lastName,
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => 'Last Name',
        },
        { accessorKey: 'age', header: () => 'Age', size: 50 },
        { accessorKey: 'visits', header: () => 'Visits', size: 50 },
        { accessorKey: 'status', header: 'Status' },
        { accessorKey: 'progress', header: 'Profile Progress', size: 80 },
      ],
      get data() {
        return data
      },
      initialState: {
        pagination: { pageSize: 20, pageIndex: 0 },
        // rowPinning: { top: ['0'], bottom: ['1'] }, // pin rows on first render
      },
      get state() {
        return {
          expanded: expanded(),
          rowPinning: rowPinning(),
        }
      },
      onExpandedChange: setExpanded,
      onRowPinningChange: setRowPinning,
      getSubRows: (row) => row.subRows,
      get keepPinnedRows() {
        return keepPinnedRows
      },
      // atoms: { rowPinning: rowPinningAtom }, // preferred: own pinning state with an external atom
      // enableRowPinning: row => row.original.age > 18, // allow pinning only for matching rows; default true
      debugTable: true,
      debugAll: true,
    },
  )
  const pagination = $derived(table.atoms.pagination.get())
</script>

{#snippet PinCell(row: ReturnType<typeof table.getRowModel>['rows'][0])}
  {#if row.getIsPinned()}
    <button
      onclick={() =>
        row.pin(false, includeLeafRows, includeParentRows)
      }
    >
      ❌
    </button>
  {:else}
    <div style="display: flex; gap: 4px">
      <button
        onclick={() =>
          row.pin('top', includeLeafRows, includeParentRows)
        }
      >
        ⬆️
      </button>
      <button
        onclick={() =>
          row.pin('bottom', includeLeafRows, includeParentRows)
        }
      >
        ⬇️
      </button>
    </div>
  {/if}
{/snippet}

{#snippet ExpandCell(row: ReturnType<typeof table.getRowModel>['rows'][0])}
  <div style="padding-left: {row.depth * 2}rem">
    {#if row.getCanExpand()}
      <button
        onclick={row.getToggleExpandedHandler()}
        style="cursor: pointer"
      >
        {row.getIsExpanded() ? '👇' : '👉'}
      </button>
    {:else}
      *
    {/if}
  </div>
{/snippet}

{#snippet ExpandAllButton()}
  <button onclick={table.getToggleAllRowsExpandedHandler()}>
    {table.getIsAllRowsExpanded() ? '👇' : '👉'}{' '}First Name
  </button>
{/snippet}

{#snippet PinnedRow(row: ReturnType<typeof table.getRowModel>['rows'][0])}
  <tr
    style="background-color: lightblue; position: sticky; top: {row.getIsPinned() === 'top' ? `${row.getPinnedIndex() * 26 + 48}px` : 'auto'}; bottom: {row.getIsPinned() === 'bottom' ? `${(table.getBottomRows().length - 1 - row.getPinnedIndex()) * 26}px` : 'auto'}"
  >
    {#each row.getAllCells() as cell (cell.id)}
      <td>
        {#if cell.column.id === 'pin'}
          {@render PinCell(row)}
        {:else if cell.column.id === 'firstName'}
          {@render ExpandCell(row)}
          <FlexRender cell={cell} />
        {:else}
          <FlexRender cell={cell} />
        {/if}
      </td>
    {/each}
  </tr>
{/snippet}

{#snippet Filter(column: Column<typeof features, Person>, tableRef: SvelteTable<typeof features, Person>)}
  {@const firstValue = tableRef
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)}

  {#if typeof firstValue === 'number'}
    <div class="filter-row">
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[0] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: any) => [(e.target as HTMLInputElement).value, old?.[1]])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[1] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: any) => [old?.[0], (e.target as HTMLInputElement).value])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  {:else}
    <input
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      oninput={(e) => column.setFilterValue((e.target as HTMLInputElement).value)}
      placeholder="Search..."
      class="filter-select"
    />
  {/if}
{/snippet}

<div class="app">
  <div class="demo-root container">
    <div>
      <button onclick={() => refreshData()}>Regenerate Data</button>
      <button onclick={() => stressTest()}>Stress Test (200k rows)</button>
    </div>
    <div class="spacer-sm"></div>
    <table>
      <thead>
        {#each table.getHeaderGroups() as headerGroup (headerGroup.id)
        }
          <tr>
            {#each headerGroup.headers as header (header.id)}
              <th colSpan={header.colSpan}>
                {#if !header.isPlaceholder}
                  {#if header.column.id === 'firstName'}
                    {@render ExpandAllButton()}
                  {:else}
                    <FlexRender header={header} />
                  {/if}
                  {#if header.column.getCanFilter()}
                    <div>
                      {@render Filter(header.column, table)}
                    </div>
                  {/if}
                {/if}
              </th>
            {/each}
          </tr>
        {/each}
      </thead>
      <tbody>
        {#each table.getTopRows() as row (row.id)}
          {@render PinnedRow(row)}
        {/each}
        {#each copyPinnedRows ? table.getRowModel().rows : table.getCenterRows() as row (row.id)}
          <tr>
            {#each row.getAllCells() as cell (cell.id)}
              <td>
                {#if cell.column.id === 'pin'}
                  {@render PinCell(row)}
                {:else if cell.column.id === 'firstName'}
                  {@render ExpandCell(row)}
                  <FlexRender cell={cell} />
                {:else}
                  <FlexRender cell={cell} />
                {/if}
              </td>
            {/each}
          </tr>
        {/each}
        {#each table.getBottomRows() as row (row.id)}
          {@render PinnedRow(row)}
        {/each}
      </tbody>
    </table>
  </div>

  <div class="spacer-sm"></div>
  <div class="controls">
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(0)
      }
      disabled={!table.getCanPreviousPage()}
    >
      {'<<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.previousPage()}
      disabled={!table.getCanPreviousPage()}
    >
      {'<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.nextPage()}
      disabled={!table.getCanNextPage()}
    >
      {'>'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(table.getPageCount() - 1)}
      disabled={!table.getCanNextPage()}
    >
      {'>>'}
    </button>
    <span class="inline-controls">
      <div>Page</div>
      <strong>
        {(pagination.pageIndex + 1).toLocaleString()} of{' '}
        {table.getPageCount().toLocaleString()}
      </strong>
    </span>
    <span class="inline-controls">
      | Go to page:
      <input
        type="number"
        min="1"
        max={table.getPageCount()}
        value={pagination.pageIndex + 1}
        oninput={(e) => {
          const page = (e.target as HTMLInputElement).value
            ? Number((e.target as HTMLInputElement).value) - 1
            : 0
          table.setPageIndex(page)
        }}
        class="page-size-input"
      />
    </span>
    <select
      value={pagination.pageSize}
      onchange={(e) => table.setPageSize(Number((e.target as HTMLSelectElement).value))}
    >
      {#each [10, 20, 30, 40, 50] as pageSize}
        <option value={pageSize}>Show {pageSize}</option>
      {/each}
    </select>
  </div>
  <div class="spacer-sm"></div>
  <hr />
  <br />
  <div class="vertical-options">
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={keepPinnedRows}
          onchange={() => keepPinnedRows = !keepPinnedRows}
        />
        Keep/Persist Pinned Rows across Pagination and Filtering
      </label>
    </div>
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={includeLeafRows}
          onchange={() => includeLeafRows = !includeLeafRows}
        />
        Include Leaf Rows When Pinning Parent
      </label>
    </div>
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={includeParentRows}
          onchange={() => includeParentRows = !includeParentRows}
        />
        Include Parent Rows When Pinning Child
      </label>
    </div>
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={copyPinnedRows}
          onchange={() => copyPinnedRows = !copyPinnedRows}
        />
        Duplicate/Keep Pinned Rows in main table
      </label>
    </div>
  </div>
  <pre data-testid="table-state">{JSON.stringify(table.store.get(), null, 2)}</pre>
</div>
<script lang="ts">
  import {
    columnFilteringFeature,
    columnSizingFeature,
    createExpandedRowModel,
    createFilteredRowModel,
    createPaginatedRowModel,
    createTable,
    createTableState,
    filterFn_includesString,
    filterFn_inNumberRange,
    FlexRender,
    rowExpandingFeature,
    rowPaginationFeature,
    rowPinningFeature,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type {
    Column,
    ExpandedState,
    RowPinningState,
    SvelteTable,
  } from '@tanstack/svelte-table'
  import type { Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    columnSizingFeature,
    rowPinningFeature,
    rowExpandingFeature,
    columnFilteringFeature,
    rowPaginationFeature,
    filteredRowModel: createFilteredRowModel(),
    expandedRowModel: createExpandedRowModel(),
    paginatedRowModel: createPaginatedRowModel(),
    filterFns: {
      includesString: filterFn_includesString,
      inNumberRange: filterFn_inNumberRange,
    },
  })

  const [rowPinning, setRowPinning] = createTableState<RowPinningState>({
    top: [],
    bottom: [],
  })
  const [expanded, setExpanded] = createTableState<ExpandedState>({})

  let keepPinnedRows = $state(true)
  let includeLeafRows = $state(true)
  let includeParentRows = $state(false)
  let copyPinnedRows = $state(false)

  let data = $state(makeData(1_000, 2, 2))
  const refreshData = () => { data = makeData(1_000, 2, 2) }
  const stressTest = () => { data = makeData(200_000, 2, 2) }

  const table = createTable(
    {
      features,
      columns: [
        {
          id: 'pin',
          header: () => 'Pin',
          cell: ({ row }) => {
            if (row.getIsPinned()) {
              return 'pinned'
            }
            return 'not-pinned'
          },
        },
        {
          accessorKey: 'firstName',
          header: () => 'First Name',
          cell: ({ getValue }) => getValue(),
          footer: (props) => props.column.id,
        },
        {
          accessorFn: (row) => row.lastName,
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => 'Last Name',
        },
        { accessorKey: 'age', header: () => 'Age', size: 50 },
        { accessorKey: 'visits', header: () => 'Visits', size: 50 },
        { accessorKey: 'status', header: 'Status' },
        { accessorKey: 'progress', header: 'Profile Progress', size: 80 },
      ],
      get data() {
        return data
      },
      initialState: {
        pagination: { pageSize: 20, pageIndex: 0 },
        // rowPinning: { top: ['0'], bottom: ['1'] }, // pin rows on first render
      },
      get state() {
        return {
          expanded: expanded(),
          rowPinning: rowPinning(),
        }
      },
      onExpandedChange: setExpanded,
      onRowPinningChange: setRowPinning,
      getSubRows: (row) => row.subRows,
      get keepPinnedRows() {
        return keepPinnedRows
      },
      // atoms: { rowPinning: rowPinningAtom }, // preferred: own pinning state with an external atom
      // enableRowPinning: row => row.original.age > 18, // allow pinning only for matching rows; default true
      debugTable: true,
      debugAll: true,
    },
  )
  const pagination = $derived(table.atoms.pagination.get())
</script>

{#snippet PinCell(row: ReturnType<typeof table.getRowModel>['rows'][0])}
  {#if row.getIsPinned()}
    <button
      onclick={() =>
        row.pin(false, includeLeafRows, includeParentRows)
      }
    >
      ❌
    </button>
  {:else}
    <div style="display: flex; gap: 4px">
      <button
        onclick={() =>
          row.pin('top', includeLeafRows, includeParentRows)
        }
      >
        ⬆️
      </button>
      <button
        onclick={() =>
          row.pin('bottom', includeLeafRows, includeParentRows)
        }
      >
        ⬇️
      </button>
    </div>
  {/if}
{/snippet}

{#snippet ExpandCell(row: ReturnType<typeof table.getRowModel>['rows'][0])}
  <div style="padding-left: {row.depth * 2}rem">
    {#if row.getCanExpand()}
      <button
        onclick={row.getToggleExpandedHandler()}
        style="cursor: pointer"
      >
        {row.getIsExpanded() ? '👇' : '👉'}
      </button>
    {:else}
      *
    {/if}
  </div>
{/snippet}

{#snippet ExpandAllButton()}
  <button onclick={table.getToggleAllRowsExpandedHandler()}>
    {table.getIsAllRowsExpanded() ? '👇' : '👉'}{' '}First Name
  </button>
{/snippet}

{#snippet PinnedRow(row: ReturnType<typeof table.getRowModel>['rows'][0])}
  <tr
    style="background-color: lightblue; position: sticky; top: {row.getIsPinned() === 'top' ? `${row.getPinnedIndex() * 26 + 48}px` : 'auto'}; bottom: {row.getIsPinned() === 'bottom' ? `${(table.getBottomRows().length - 1 - row.getPinnedIndex()) * 26}px` : 'auto'}"
  >
    {#each row.getAllCells() as cell (cell.id)}
      <td>
        {#if cell.column.id === 'pin'}
          {@render PinCell(row)}
        {:else if cell.column.id === 'firstName'}
          {@render ExpandCell(row)}
          <FlexRender cell={cell} />
        {:else}
          <FlexRender cell={cell} />
        {/if}
      </td>
    {/each}
  </tr>
{/snippet}

{#snippet Filter(column: Column<typeof features, Person>, tableRef: SvelteTable<typeof features, Person>)}
  {@const firstValue = tableRef
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)}

  {#if typeof firstValue === 'number'}
    <div class="filter-row">
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[0] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: any) => [(e.target as HTMLInputElement).value, old?.[1]])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={((column.getFilterValue() as any)?.[1] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: any) => [old?.[0], (e.target as HTMLInputElement).value])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  {:else}
    <input
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      oninput={(e) => column.setFilterValue((e.target as HTMLInputElement).value)}
      placeholder="Search..."
      class="filter-select"
    />
  {/if}
{/snippet}

<div class="app">
  <div class="demo-root container">
    <div>
      <button onclick={() => refreshData()}>Regenerate Data</button>
      <button onclick={() => stressTest()}>Stress Test (200k rows)</button>
    </div>
    <div class="spacer-sm"></div>
    <table>
      <thead>
        {#each table.getHeaderGroups() as headerGroup (headerGroup.id)
        }
          <tr>
            {#each headerGroup.headers as header (header.id)}
              <th colSpan={header.colSpan}>
                {#if !header.isPlaceholder}
                  {#if header.column.id === 'firstName'}
                    {@render ExpandAllButton()}
                  {:else}
                    <FlexRender header={header} />
                  {/if}
                  {#if header.column.getCanFilter()}
                    <div>
                      {@render Filter(header.column, table)}
                    </div>
                  {/if}
                {/if}
              </th>
            {/each}
          </tr>
        {/each}
      </thead>
      <tbody>
        {#each table.getTopRows() as row (row.id)}
          {@render PinnedRow(row)}
        {/each}
        {#each copyPinnedRows ? table.getRowModel().rows : table.getCenterRows() as row (row.id)}
          <tr>
            {#each row.getAllCells() as cell (cell.id)}
              <td>
                {#if cell.column.id === 'pin'}
                  {@render PinCell(row)}
                {:else if cell.column.id === 'firstName'}
                  {@render ExpandCell(row)}
                  <FlexRender cell={cell} />
                {:else}
                  <FlexRender cell={cell} />
                {/if}
              </td>
            {/each}
          </tr>
        {/each}
        {#each table.getBottomRows() as row (row.id)}
          {@render PinnedRow(row)}
        {/each}
      </tbody>
    </table>
  </div>

  <div class="spacer-sm"></div>
  <div class="controls">
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(0)
      }
      disabled={!table.getCanPreviousPage()}
    >
      {'<<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.previousPage()}
      disabled={!table.getCanPreviousPage()}
    >
      {'<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.nextPage()}
      disabled={!table.getCanNextPage()}
    >
      {'>'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(table.getPageCount() - 1)}
      disabled={!table.getCanNextPage()}
    >
      {'>>'}
    </button>
    <span class="inline-controls">
      <div>Page</div>
      <strong>
        {(pagination.pageIndex + 1).toLocaleString()} of{' '}
        {table.getPageCount().toLocaleString()}
      </strong>
    </span>
    <span class="inline-controls">
      | Go to page:
      <input
        type="number"
        min="1"
        max={table.getPageCount()}
        value={pagination.pageIndex + 1}
        oninput={(e) => {
          const page = (e.target as HTMLInputElement).value
            ? Number((e.target as HTMLInputElement).value) - 1
            : 0
          table.setPageIndex(page)
        }}
        class="page-size-input"
      />
    </span>
    <select
      value={pagination.pageSize}
      onchange={(e) => table.setPageSize(Number((e.target as HTMLSelectElement).value))}
    >
      {#each [10, 20, 30, 40, 50] as pageSize}
        <option value={pageSize}>Show {pageSize}</option>
      {/each}
    </select>
  </div>
  <div class="spacer-sm"></div>
  <hr />
  <br />
  <div class="vertical-options">
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={keepPinnedRows}
          onchange={() => keepPinnedRows = !keepPinnedRows}
        />
        Keep/Persist Pinned Rows across Pagination and Filtering
      </label>
    </div>
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={includeLeafRows}
          onchange={() => includeLeafRows = !includeLeafRows}
        />
        Include Leaf Rows When Pinning Parent
      </label>
    </div>
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={includeParentRows}
          onchange={() => includeParentRows = !includeParentRows}
        />
        Include Parent Rows When Pinning Child
      </label>
    </div>
    <div>
      <label class="label-offset">
        <input
          type="checkbox"
          checked={copyPinnedRows}
          onchange={() => copyPinnedRows = !copyPinnedRows}
        />
        Duplicate/Keep Pinned Rows in main table
      </label>
    </div>
  </div>
  <pre data-testid="table-state">{JSON.stringify(table.store.get(), null, 2)}</pre>
</div>